/*
 * DrawUtils.java
 *
 * Created on 27. Mai 2006, 04:58
 */

package java2d1;

import com.sun.image.codec.jpeg.JPEGCodec;
import com.sun.image.codec.jpeg.JPEGImageDecoder;
import java.awt.Color;
import java.awt.GradientPaint;
import java.awt.Paint;
import java.awt.Shape;
import java.awt.TexturePaint;
import java.awt.geom.Arc2D;
import java.awt.geom.Ellipse2D;
import java.awt.geom.GeneralPath;
import java.awt.geom.Rectangle2D;
import java.awt.geom.RoundRectangle2D;
import java.awt.image.BufferedImage;
import java.io.InputStream;

/**
 * Definiert zu zeichnende Objekte und Farben
 * @author Arnd
 */
public class DrawUtils {
    private static DrawUtils ref;
    private final Paint redPaint = //rote Farbe definieren
    private final Paint bluePaint = //blaue Farbe definieren
    private final Paint gradientPaint = //GradientPaint definieren
    private Paint textPaint;
    
    private final Shape roundRect = //Rechteck mit abgerundeten Ecken definieren
    private final Shape rect = //Rechteck definieren
    private final Shape circle = //Kreis definieren
    private final Shape arc = //Kreisbogen defineren
    private Shape generalPath;
    
    /** Creates a new instance of DrawUtils */
    private DrawUtils() {
        //Bild laden
        BufferedImage texture = null;
        try {
            InputStream in=this.getClass().getResourceAsStream("./mauer.jpg");
            JPEGImageDecoder decoder = JPEGCodec.createJPEGDecoder(in);
            texture = decoder.decodeAsBufferedImage();
            in.close();
        } catch (Exception e) {
            e.printStackTrace();
        };
        
        //Fr Instanzvariable text neues TexturePaint object mit Mauer-Textur
        //erzeugen und zuweisen
        
        
    }
    
    public static synchronized DrawUtils getInstance() {
        if (ref == null) {
            ref = new DrawUtils();
        }
        return ref;
    }
    
    public Paint getRedPaint() {
        return redPaint;
    }
    
    public Paint getBluePaint() {
        return bluePaint;
    }
    
    
    public Paint getGradientPaint() {
        return gradientPaint;
    }
    
    public Paint getTextPaint() {
        return textPaint;
    }
    
    private void setTextPaint(Paint textPaint) {
        this.textPaint = textPaint;
    }
    
    public Shape getRoundRect() {
        return roundRect;
    }
    
    public Shape getRect() {
        return rect;
    }
    
    
    public Shape getCircle() {
        return circle;
    }
    
    
    public Shape getArc() {
        return arc;
    }

    


    public Shape getGeneralPath() {
        
        if (generalPath==null) {
            //GeneralPath-Objekt wie vorgegeben erzeugen
            // und generalPath Variable zuweisen
            
            //Pfad-Koordinaten:
            //116.0f,93.0f
            //97.0f,2.0f  
            //59.0f,92.0f 
            //35.0f,1.0f  
            //10.0f,90.0f 
            //140.0f,1.0f 
            //60.0f,120.0f
            // 2.0f,1.0f  
            
            
        }
        return generalPath;
    }
    
    
    
    
}
