
package java2d1;

import java.awt.Canvas;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.GradientPaint;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.RenderingHints;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import java.awt.geom.Rectangle2D;
import java.util.Iterator;
import javax.swing.*;
import java.awt.geom.*;
import java.awt.image.BufferedImage;
import java.util.List;

/**
 * Komponente, auf der gezeichnet wird
 * @author arnd
 */
public class RenderCanvas extends Canvas {
    
    private RenderingHints qualityHints;
    private Graphics2D graphics2D;
    private ObjectRenderer objectRenderer;
    private CanvasModel cModel;
    
    
    RenderCanvas(CanvasModel cm) {
        cModel = cm;
        this.objectRenderer = new ObjectRenderer();
        this.qualityHints = new RenderingHints(null);        
        
        //Hintergrund auf schwarz setzen

        
        addMouseListener(new MouseAdapter() {
            public void mousePressed(MouseEvent e) {
                //Mauskoordinaten holen und in int x,y ablegen

                
                //neue AffineTransform 'transform' erzeugen mit den Mauskoord. (x,y) fr
                //Translationswerte

                
                //Winkel vom State-Objekt holen, Rotation zur Transformation hinzufgen

                
                //GeometricObject mit den in State enthaltenen Optionen 
                //und der erzeugten AffineTransform-Instanz instanziieren 
                GeometricObject go = new GeometricObject(State.getShapeOption(),State.getFillOption(),  transform);
                
                //Objekt zur Liste hinzufgen
                cModel.addObject(go);
                
                
                if(State.isAntialiasingEnabled()) {
                    //ber RenderingHints (qualityHints Object) Antialiasing einschalten

                } else {
                    //ber RenderingHints (qualityHints Object) Antialiasing ausschalten
                    
                }
                if(State.isDitheringEnabled()) {
                    //ber RenderingHints (qualityHints Object) Dithering einschalten
                    
                } else {
                    //ber RenderingHints (qualityHints Object) Dithering ausschalten
                    
                }
                
                //Canvas neu zeichnen
                
            }
        });

        
    }
    
    
    public void paint(Graphics g) {
        //Casten: Graphics g to Graphics2D graphics2D
        
        
        //RenderingHints setzen
        
        
        //Liste der Objekte durchgehen,
        //Jedes Objekt zeichnen
        List objects = cModel.getObjects();
        Iterator it = objects.iterator();
        while (it.hasNext()) {
            this.objectRenderer.renderObject(graphics2D, (GeometricObject)it.next());
        }
        
        
    }
    
    
    public Dimension getPreferredSize() {
        return new Dimension(400,400);
    }
}
